<template>
  <g>
    <rect
      :width="end - start + TIMELINE_PADDING * 2"
      height="20"
      :x="start - TIMELINE_PADDING"
      :y="y"
      fill="#00000004"
    />
    <timeline-marker
      v-for="(marker, index) in timeMarkers"
      :key="index"
      :y="y + 14"
      :position="marker.position"
      :label="marker.label"
      :zoom="zoom"
    />
  </g>
</template>

<script lang="ts">
import type {
  Pixel, Rect, Unit,
} from '@/data';
import {
  Component, Prop, Vue,
} from 'vue-property-decorator';
import TimelineMarker from './TimelineMarker.vue';

@Component({
  components: {
    TimelineMarker,
  },
})
export default class CanvasTimelineMusical extends Vue {
  @Prop({ default: 0 })
  y!: number;

  @Prop({ required: true })
  width!: Pixel;

  @Prop({ default: 1 })
  zoom!: number;

  @Prop({ required: true })
  pixelUnit!: Unit<Pixel>;

  @Prop({ required: true })
  viewRect!: Rect;

  TIMELINE_PADDING = 50;

  VISIBLE_MARKER = 6;

  timeMarkers: Array<{position: Pixel, label: string}> = [];

  start: Pixel = 0 as Pixel;

  end: Pixel = 0 as Pixel;

  interval = 1;
}
</script>
